# Class BodyContent

java.lang.Object
java.io.Writer
jakarta.servlet.jsp.JspWriter
jakarta.servlet.jsp.tagext.BodyContent

All Implemented Interfaces:
  `Closeable, Flushable, Appendable, AutoCloseable`

public abstract class BodyContent extends JspWriter
An encapsulation of the evaluation of the body of an action so it is available to a tag handler. BodyContent is a subclass of JspWriter.

Note that the content of BodyContent is the result of evaluation, so it will not contain actions and the like, but the result of their invocation.

BodyContent has methods to convert its contents into a String, to read its contents, and to clear the contents.

The buffer size of a BodyContent object is unbounded. A BodyContent object cannot be in autoFlush mode. It is not possible to invoke flush on a BodyContent object, as there is no backing stream.

Instances of BodyContent are created by invoking the pushBody and popBody methods of the PageContext class. A BodyContent is enclosed within another JspWriter (maybe another BodyContent object) following the structure of their associated actions.

A BodyContent is made available to a BodyTag through a setBodyContent() call. The tag handler can use the object until after the call to doEndTag().

## Field Summary

### Fields inherited from class JspWriter

`autoFlush, bufferSize, DEFAULT_BUFFER, NO_BUFFER, UNBOUNDED_BUFFER`

### Fields inherited from class Writer

`lock`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`BodyContent(JspWriter e)`
Protected constructor.

## Method Summary

Modifier and Type
Method
Description
`void`
`clearBody()`
Clear the body without throwing any exceptions.
`void`
`flush()`
Redefined flush() so it is not legal.
`JspWriter`
`getEnclosingWriter()`
Get the enclosing JspWriter.
`abstract Reader`
`getReader()`
Return the value of this BodyContent as a Reader.
`abstract String`
`getString()`
Return the value of the BodyContent as a String.
`abstract void`
`writeOut(Writer out)`
Write the contents of this BodyContent into a Writer.

### Methods inherited from class JspWriter

`clear, clearBuffer, close, getBufferSize, getRemaining, isAutoFlush, newLine, print, print, print, print, print, print, print, print, print, println, println, println, println, println, println, println, println, println, println`

### Methods inherited from class Writer

`append, append, append, nullWriter, write, write, write, write, write`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### BodyContent

protected BodyContent(JspWriter e)
Protected constructor. Unbounded buffer, no auto flushing.

Parameters:
  `e` - the enclosing JspWriter

## Method Details

### flush

public void flush() throws IOException
Redefined flush() so it is not legal.

It is not valid to flush a BodyContent because there is no backing stream behind it.

Specified by:
  `flush` in interface `Flushable`
Specified by:
  `flush` in class `JspWriter`
Throws:
  `IOException` - always thrown

### clearBody

public void clearBody()
Clear the body without throwing any exceptions.

### getReader

public abstract Reader getReader()
Return the value of this BodyContent as a Reader.

Returns:
  the value of this BodyContent as a Reader

### getString

public abstract String getString()
Return the value of the BodyContent as a String.

Returns:
  the value of the BodyContent as a String

### writeOut

public abstract void writeOut(Writer out) throws IOException
Write the contents of this BodyContent into a Writer. Subclasses may optimize common invocation patterns.

Parameters:
  `out` - The writer into which to place the contents of this body evaluation
Throws:
  `IOException` - if an I/O error occurred while writing the contents of this BodyContent to the given Writer

### getEnclosingWriter

public JspWriter getEnclosingWriter()
Get the enclosing JspWriter.

Returns:
  the enclosing JspWriter passed at construction time